
#include <windows.h>		//    Windows 
#include <math.h>
#include <time.h>
#include <stdlib.h>


	//   
LONG WINAPI MyWinP (HWND,UINT,WPARAM,LPARAM);

	//  .     Windows 
int WINAPI WinMain( HINSTANCE hInstance, 
					HINSTANCE, LPSTR, int nCmdShow)
{
	char ProgName[]	=	"   "
									"  ";
	char Title[] = "   ";

	HWND hWnd;			//  
	MSG msg;			// ,   
	WNDCLASS w;			//    
								//  :
	w.lpszClassName = ProgName;	//   
	w.hInstance = hInstance; 	//   
	w.lpfnWndProc	= MyWinP;	//    
	w.hCursor	 = NULL;		//  
								//  
	w.hIcon	= LoadIcon(hInstance,ProgName);
	w.lpszMenuName	= NULL;		//   

								//     
	w.hbrBackground	= (HBRUSH)GetStockObject (LTGRAY_BRUSH);

								//  ,   
	w.style	= CS_HREDRAW | CS_VREDRAW;

			//     
	w.cbClsExtra = 0;

			//      
	w.cbWndExtra = 0;

			//    
	if (!RegisterClass (&w))
		return FALSE;		//    

			//      
	hWnd = CreateWindow( ProgName,Title,
				WS_OVERLAPPEDWINDOW|WS_HSCROLL|WS_VSCROLL,
				0, 0, CW_USEDEFAULT, CW_USEDEFAULT, NULL,
				NULL, hInstance, NULL );

	ShowWindow(hWnd,nCmdShow);			//   
										//     
	UpdateWindow(hWnd);					//     
	
	SetTimer(hWnd,1,1000,0);			//   
	SetTimer(hWnd,2,500,0);				//   
	
	while (GetMessage(&msg,0,0,0))		//   
	{		//   (   )
		TranslateMessage(&msg);
		DispatchMessage(&msg);			//   
	}
			//    
	return (msg.wParam);
}


		// ========   ========//
LONG WINAPI MyWinP (HWND hWnd, UINT msg, WPARAM wParam,
					 LPARAM lParam)
{
	PAINTSTRUCT ps;		//       
	HDC hdc;			//   
	HBRUSH hOld, hNew;	//  

	static int N = 12;	//   
	static int D = 2;	//  ,  
						//   (   )
	const double p2 = 2*3.14159265359;
	int x1, y1, x2, y2;			//  " "
	int i;						//  
	static short xw, yw, r;		//    

			//       
	r  = yw < xw ? yw/D : xw/D;

	switch(msg)			//   
	{

	case WM_PAINT:
		hdc = BeginPaint(hWnd,&ps);
		SetTextAlign (hdc,TA_CENTER);	//  
		SetBkMode (hdc,TRANSPARENT);	//   

	#ifdef STRICT
		TextOut (hdc,xw,20," Strict",12);
	#else
		TextOut (hdc,xw,20," No Strict",16);
	#endif

			//    
		srand ((unsigned)time (NULL));

		for (i=0; i<N; i++)	//     
		{
				//     
				//     
				//   
			BYTE red	= rand ()%256;
			BYTE green	= rand()%256;
			BYTE blue	= rand()%256;
				//   
			long color = RGB(red,green,blue);
				//  
			hNew = CreateSolidBrush (color);
				//  
			hOld = (HBRUSH)SelectObject(hdc,hNew);
				//   
				//       Pie
			x1 = (int)(xw+r*cos(p2*i/N));
			y1 = (int)(yw-r*sin(p2*i/N));
			x2 = (int)(xw+r*cos(p2*(i+1)/N));
			y2 = (int)(yw-r*sin(p2*(i+1)/N));
				//  
			Pie (hdc,xw-r,yw-r,xw+r,yw+r,x1,y1,x2,y2);
				//    
			SelectObject(hdc,hOld);
			DeleteObject(hNew);
		}
		ValidateRect(hWnd,0);  
		EndPaint(hWnd,&ps);
		break;

	case WM_TIMER:
		if (wParam==1)			//    ,
			N = rand()%128+2;	//    
		else					// ,
			D = rand()%4+1;		//     
		InvalidateRect(hWnd,0,TRUE);
		break;
	
	case WM_SIZE:
			//     
		xw = LOWORD(lParam)/2;
			//     
		yw = HIWORD(lParam)/2;
		break;

	case WM_CLOSE:
		if (MessageBox (hWnd,"  ?", "",
						 MB_YESNOCANCEL) == IDYES) 
			DestroyWindow(hWnd);			//  
		else
			return 0L;
		break;

	case WM_DESTROY:
			//  ,   (thread)  
		PostQuitMessage(0);
		break;
	default:		//   
		return (DefWindowProc(hWnd,msg,wParam,lParam));
	}
	return 0L;
}
